Page MenuHomePhabricator

Wiktionary Cognate Dashboard Interface Translations
Closed, ResolvedPublic

Description

Event Timeline

Restricted Application added a subscriber: Aklapper. · View Herald TranscriptJul 23 2018, 1:56 PM

@Lea_Lacroix_WMDE The documentation is found at Meta.

Please review. Thanks.

@GoranSMilovanovic Thanks, it looks good! I'll reorganize it a bit (keep the "using" instructions at the top and moving the more technical ones at the bottom. Then I'll prepare it for translation.

To allow translation of the interface, you can just create a /Interface subpage of this one, with the English text, and I'll make it translatable as well.

@Lea_Lacroix_WMDE https://meta.wikimedia.org/wiki/Wiktionary_Cognate_Dashboard/Interface is now created (copy + paste from the source documentation page). Please let me know if this is what you need. Thanks!

@GoranSMilovanovic I mean, copy paste all the content that you use on the dashboard, so other people can provide translation :) So for example, the small explaination texts that are at the top of the pages.

@Lea_Lacroix_WMDE :) I understand now what you need, I thought we were about to translate the documentation pages. Done, please check: https://meta.wikimedia.org/wiki/Wiktionary_Cognate_Dashboard/Interface

@GoranSMilovanovic Here we go :)

  • The documentation is now translatable (by clicking on the small link "translate the page")
  • The interface content is also ready for translation - I added every small piece of text, but if not 100% of the interface is translated, I guess it's OK.
  • I made the French version of the interface content! You can include it in the dashboard.
  • In order to give more visibility to these features, I think it would be interested to have some new buttons on the dashboard, for example on the top right corner, displaying:
    • a menu to select the language of the interface
    • a button "Documentation"
    • a button "Help translating the interface"

Thanks a lot for taking care of this. I know that it's some unexpected work, but since we're targeting a very multilingual community, I think it's important to provide the tools for them so they can work in their favourite language :)

If I understand correctly, you're waiting for a review from Team Analytics. After that, can we go for a big announcement to all the Wiktionaries?

GoranSMilovanovic added a comment.EditedAug 6 2018, 12:38 AM

@Lea_Lacroix_WMDE

The documentation is now translatable (by clicking on the small link "translate the page")

Goran: Nice.

The interface content is also ready for translation - I added every small piece of text, but if not 100% of the interface is translated, I guess it's OK.

Goran: Perfect.

I made the French version of the interface content! You can include it in the dashboard.

Goran: Great, I will provide a Serbian translation and translate the documentation page too. Since I'm studying Italian for almost a year already, I might try Italian too.

In order to give more visibility to these features, I think it would be interested to have some new buttons on the dashboard, for example on the top right corner, displaying:

  • a menu to select the language of the interface
  • a button "Documentation"
  • a button "Help translating the interface"

Goran: Will do.

Thanks a lot for taking care of this. I know that it's some unexpected work, but since we're targeting a very multilingual community, I think it's important to provide the tools for them so they can work in their favourite language :)

Goran: Of course. At your service.

If I understand correctly, you're waiting for a review from Team Analytics. After that, can we go for a big announcement to all the Wiktionaries?

Goran: We have the approval from the Analytics-Engineering team (T199851#4476889). However, a big announcement will have to wait for the following to take place:

  • Adapting the Dashboard to a multilingual version, having in mind many possible future translations of the interface;
  • Completing the experimentation on search vectors that could (hopefully) speed-up the operation of the Compare tab, where I predict high user interest but which is currently computationally quite demanding and thus slow for large Wiktionaries;
  • "Productionizing" the Dashboard, which in this context means: putting everything on regular daily updates, syncing the Dashboard with the production machinery (where we crack the numbers that the Dashboard reports upon), and deciding upon what data sets will the Dashboard process entirely on the back-end and what data sets will be downloaded on the client side for processing (and the decision is not simple in this case because the data sets are potentially large).

None of these is too complicated, but learning by trial-and-error will be taking placing until I figure what is the optimal solution. That being said: if I complete everything until the end of this week and we plan your big announcement to take place in the beginning of the next, what that be too late?

Hey @GoranSMilovanovic,
Thanks a lot! I understand, and I'm fine about an announcement next week.
However, if the "translatability" of the tool is an issue that could block the process for longer, I'd choose to announce it anyway. We can say that it's a first version, that the board will continuously be improved, and people can already translate the documentation and the interface onwiki.
Let's see how it goes :)

@Lea_Lacroix_WMDE

However, if the "translatability" of the tool is an issue that could block the process for longer, I'd choose to announce it anyway.

It is not an issue, I just need to turn something that is a constant now into a variable and import the existing translations. I just want to make sure that the procedure is set so to allow me to import any future translation with minimal dashboard maintenance costs in terms of time and effort. I will let you know as soon as the Dashboard is ready to be announced!

@Lea_Lacroix_WMDE

Adapting the Dashboard to a multilingual version, having in mind many possible future translations of the interface.

Well, this is going to take a while. Before I've seen you translation of the interface, I thought you would like to have only the instructions (what is found on the top of each page) translated. However, then I have realized that we need the full interface translated, including the titles of the tab, etc. With the current technology (Shiny dashboards), this calls for a JS developer who could give me a hand - otherwise, working from R solely (as I do), I can't touch the titles of the tabs, for example.

My suggestion to you: let's go with the English interface version now, and see later what to do about the multilingual version. Agree? Let me know.

The following:

a button "Documentation"
a button "Help translating the interface"

is now taken care of.

GoranSMilovanovic renamed this task from Wiktionary Cognate Dashboard Documentation to Wiktionary Cognate Dashboard Interface Translations.Aug 9 2018, 1:28 AM
GoranSMilovanovic updated the task description. (Show Details)
Pamputt added a subscriber: Pamputt.Aug 9 2018, 5:26 AM

@GoranSMilovanovic Yes, I translated everything just to be sure. But if the instructions are translated, it's already very fine.

@Lea_Lacroix_WMDE You will find a new drop-down menu from the My Wiktionary tab (the Dashboard's landing page): Language of instructions:. Currently we have French and English.

GoranSMilovanovic closed this task as Resolved.Aug 14 2018, 3:01 PM

Closing the task as resolved. I will be watching the interface page and gradually introduce new interface translations as they get completed.

@GoranSMilovanovic @Lea_Lacroix_WMDE
Even if the current translation system "work", I think it should be improved. I think it is not possible to maintain such system over a long time. For example, what will happen when GoranSMilovanovic will not be there anymore or will not have time anymore to update translations?
In addition, I think some strings are missing (just switch to the FR language, and you will see several strings that still appear in English). This is quite difficult to find all the translatable string from the user point of view while it is easier from the developer point of view (wether we want to translate the whole interface).
A better solution, IMO, is to allow translating the interface from translatewiki. Is there any reason why not using translatewiki?
I understand that such solution require more development time but it appears to me to be a better long-term solution.
Should I open a new ticket for this request?

GoranSMilovanovic added a comment.EditedAug 23 2018, 7:07 AM

@Pamputt Please recognize that this ticket is closed.

You can open a new ticket, of course; I am sure that @Lea_Lacroix_WMDE and @Lydia_Pintscher will notify me on the priorities in relation to the Wiktionary Cognate Dashboard.

Your suggestion certainly makes sense and I agree that it presents a better long-term solution.

Constraints:

  • I have never worked with translatewiki and I don't know whether it could be used for this project; I would need to learn how to use translatewiki first.
  • I am a Data Scientist for WMDE, which means that I do not do any JS or PHP for web-development; I have the control of the dashboard's front-end from the programming language R only (because RStudio Shiny is what we use to develop and run our dashboards). As a consequence, handing over the controls of the front-end to the end-user is easy for me in some parts of the dashboard, and difficult in other parts (like the menus, the sidebar navigation, etc, where I have to go under the hood of the current technological platform and perform tweaks in JS which is run by Shiny which is in turn an abstraction over the JS Bootstrap framework).
  • Finally, in order to provide for a solution that you are proposing, I would need to develop a data model for all translations: a mapping of "strings" in different languages across all relevant elements at the front-end, and that would also take some time.

I do not think that I could start working on this before October or November 2018. @Pamputt Please take into you consideration that I run everything from (a) back-end ETL, through (b) statistical modeling when it is necessary or requested, to (c) front-end development for various data products for the (1) Wikidata team, (2) Wiktionary, (3) WMDE New editors team, and (4) WMDE Technical Wishlist team. I recognize your suggestions as highly valuable, but I simply cannot do it all at once. Thank you.

Hello @GoranSMilovanovic @Pamputt

In order to track more easily the new feature requests for the dashboard, I created T202610. I also created T202613 as a subtask for the translation issues. If you have any other request, new feature, suggestion for improvement, etc, feel free to create a subtask of T202610.

Please note that the current version of the dashboard fulfills the initial need that was requested on T166487. The dashboard will be maintained and the data will be updated in the future, but the new requests won't be developed immediately. We will analyze the needs, see what is more important for the community, estimate the resources needed for the task, and then plan the development.

I stay of course available to discuss about your ideas and questions :)

About translatewiki: it's not possible to use it because Translatewiki is an extension for a Mediawiki wiki, however, the dashboard is not based on a wiki system :) It's an independant piece of software using different technology. Therefore, the existing translation solutions we have onwiki are not applicable.